module DBgen = struct

  open Xio
  open Debug

  let start infile outfile =
    let _ =
      Debug.println ("## Starting DBgen with files "
		     ^ infile ^ " and " ^ outfile) in

    let channel = open_in infile in
    let _ = Debug.println ("## File " ^ infile ^ " successfully loaded.") in

    let lexbuf = Lexing.from_channel channel in
    let _ = Debug.println "## lexbuf successfully created." in
(*    let _ = Parsing.set_trace true in*)

    let gmod = Parser.gmod Lexer.token lexbuf in
    let _ = Debug.println "## gmodule successfully parsed." in
    let _ = close_in channel in
    let _ = Debug.println "## In channel closed." in

    let _ = Debug.println "## Coq generation start." in
    let coq_output = gmod#coq_output in
    let _ = Debug.println "## Coq generation end." in

    Xio.save outfile coq_output

end
