open Args

open Interfaces
open Definitions_lift_subst
open Definitions_named

let ordered_defs (gmod : gmodule) : definition list =
  (** basic definitions *)
  (Term (new de_bruijn_terms gmod :> terms_definition) ::
   Fun (new lift_fun gmod :> fun_definition) ::
   Fun (new subst_fun gmod :> fun_definition) ::
   []) @

  (** named definitions *)
  (if Args.is_aux "named-string" || Args.is_aux "named-nat"
   then
    Fun (new fv_permut_fun gmod :> fun_definition) ::
    Term (new named_terms gmod :> terms_definition) ::
    Fun (new named_to_db_fun gmod :> fun_definition) ::
    []
   else [])
