(**
 * Generic error utility
 *)

module Error =
  struct

    type region = (int * int) * (int * int)

    let string_of_region (reg : region) : string =
      let ((l1, c1), (l2, c2)) = reg in
      (string_of_int l1) ^ "." ^ (string_of_int c1) ^ "-" ^
      (string_of_int l2) ^ "." ^ (string_of_int c2)

    let fail (reg : region) (s : string) =
      let _ =
	prerr_string ("Error at " ^ string_of_region reg ^ ": " ^ s ^ "\n") in
      let _ = flush stderr in
      failwith "Aborting."

  end
