(**
 * Generic main structure
 *)

open Args
open Debug
open Version
open Dbgen

(* The minimum expected numbers of arguments on the command line *)
let number_param_min = 2
;;

let version =
    "DBgen " ^ Version.number ^ " (" ^ Version.date ^ ")"
;;

(**
 * calls the start function of program with the arguments list.
 *)
let run _ =
  let _ = Debug.println "# run start." in
  let _ =
    if Args.version_invoked ()
    then
      begin
	print_string (version ^ "\n"); exit 0
      end else ()
  in
  try
    let in_file = Args.get_input_file_name ()
    and out_file = Args.get_output_file_name () in
    DBgen.start in_file out_file
  with
    Failure s -> if s = "nth" then Args.usage () else failwith s

(**
 * calls run() and wait for any exception in order to display the exception message.
 *)
let main _ =
  let _ = Debug.println "# main start." in
  let _ =
(*    try*) run ()
(*    with e -> 
      begin
	print_string (Printexc.to_string e); print_newline ();
	exit 1
      end*)
  in
  exit 0
;;

let _ = Debug.println "#" in
main ()
;;
