open Version

module SyntaxModuleTemplate = struct
  let col_width = 80

  let full_comment_line =
    "(" ^ String.make (col_width - 2) '*' ^ ")"

  let start_full_comment_line =
    "(" ^ String.make (col_width - 1) '*'

  let end_full_comment_line =
    String.make (col_width - 1) '*' ^ ")"

  let empty_comment_line =
    "*" ^ String.make (col_width - 2) ' ' ^ "*"

  let comment_line_with_text s =
    "* " ^ s ^ String.make ((col_width - 4) - String.length s) ' ' ^ " *"

  let version_line =
    let version_string =
      "DBGen " ^ Version.number ^ " (" ^ Version.date ^ ")" in
    comment_line_with_text version_string

  let header =
start_full_comment_line ::
empty_comment_line ::
comment_line_with_text "Automatically generated file, do not modify" ::
empty_comment_line ::
version_line ::
comment_line_with_text "Emmanuel Polonowski, Coq v8.4" ::
empty_comment_line ::
end_full_comment_line ::
"" ::
"Require Import Arith Omega." ::
"" ::
"" ::
"(** * Syntax definition *)" ::
"" ::
"Module #gmodule#." ::
"" ::
"  Create HintDb #database#." ::
"" ::
"" ::
"  (** ** General Tactics *)" ::
"" ::
"  Hint Rewrite Plus.plus_0_r Minus.minus_diag : #database#." ::
"" ::
"  Ltac omega_tac :=" ::
"    omega || (absurd False; auto; omega)." ::
"" ::
"  Ltac fomega_tac :=" ::
"    f_equal; auto with #database#; try omega_tac." ::
"" ::
"  Ltac efomega_tac :=" ::
"    f_equal; eauto with #database#; try omega_tac." ::
"" ::
"  Ltac #crush# :=" ::
"    autorewrite with #database# in *; auto with #database#; try omega_tac;" ::
"      try match goal with" ::
"            | [ H : False |- _ ] => inversion H" ::
"          end;" ::
"      try (repeat fomega_tac; fail)." ::
"" ::
"  Ltac #ecrush# :=" ::
"    autorewrite with #database# in *; eauto with #database#; try omega_tac;" ::
"      try match goal with" ::
"            | [ H : False |- _ ] => inversion H" ::
"          end;" ::
"      try (repeat efomega_tac; fail)." ::
"" ::
"  Ltac cfail :=" ::
"    simpl; #crush#; fail." ::
[]

  let footer =
"End #gmodule#." :: []

end
