
Module IMP.

  Inductive mutable : Type :=
  | id ((* index *) x : nat).

  Inductive exp : Type :=
  | cvar ((* index *) x : nat)
  | mvar (x : mutable)
  | int (n : nat).

  Inductive comm : Type :=
  | assign (x : mutable) (e : exp)
  | inc (x : mutable)
  | dec (x : mutable)
  | block (s : seq)

  with seq : Type :=
  | empty
  | cst (e : exp) ((* bind exp in *) s : seq)
  | var ((* bind mutable in *) s : seq)
  | com (c : comm).

End IMP.
