
Module ZZZ.

  Inductive AA : Type :=
  | AAa
  | AAb
  | AAc.

  Inductive BA : Type :=
  | BAa
  | BAb (a : BA)
  | BAc (a b : BA)
  | BAd (a : BA) (b : BA).

  Inductive CA : Type :=
  | CAa
  | CAb ((* index *) a : nat)
  | CAc (a b : CA)
  | CAd (a : CA) (b : CA)
  | CAe ((* bind CA in *) a : CA)
  | CAf ((* bind 2 : CA in *) a : CA) (b : CA)
  | CAg (n : nat) ((* bind n * 2 : CA in *) a b : CA)
  | CAh (n : nat) ((* bind n * 2 : CA in *) a : CA) ((* bind CA in *) b : CA).

  Inductive DA : Type :=
  | DAa
  | DAb
  | DAc

  with DB : Type :=
  | DBa
  | DBb (a : DC)
  | DBc (a : DB) (b : DA)

  with DC : Type :=
  | DCa
  | DCb ((* index *) a : nat)
  | DCc (a : DC) (b : DB) (c : DB)
  | DCd ((* bind DC in *) a : DC)
  | DCe ((* bind 2 : DC in *) a : DB) (b : DA)
  | DCf ((* bind 2 : DC in *) a b : DB)
  | DCg (n : nat) ((* bind n * 2 : DC in *) a : DC) (b : DA).

  Inductive EA : Type :=
  | EAa
  | EAb ((* index *) a : nat)
  | EAc

  with EB : Type :=
  | EBa ((* index *) a : nat)
  | EBb ((* bind EB in *) a : EC)
  | EBc ((* bind 2 : EA in *) a : EB) (b : EA)

  with EC : Type :=
  | ECa
  | ECb ((* index *) a : nat)
  | ECc (a : EC) (b : EB) (c : EB)
  | ECd ((* bind EC in *) a : EC) (b : EC) (c : EA)
  | ECe ((* bind EC in *) a b : EC) (c : EA)
  | ECf ((* bind 2 : EA, 1 : EB in *) a : EB) (b : EA)
  | ECg (n : nat) ((* bind n * 2 : EB, n + 1 : EC in *) a : EC) ((* bind EA in *) b : EA).

  Inductive FA : Type :=
  | FAa
  | FAb (a : AA)
  | FAc (a : BA) (b : CA)
  | FAd (a : DA) (b : DB)
  | FAe (a : BA) (b : DC) (c : EB)
  | FAf (a : EA) (b : DB) (c : EC).

  Inductive GA : Type :=
  | GAa ((* index *) a : nat)
  | GAb (a : AA)
  | GAc (a : BA) ((* bind CA in *) b : CA) (g : GA)
  | GAd (a : DA) ((* bind 1 : DC, 1 : EA in *) b : DB) (g : GA)
  | GAe (a : BA) (b : DC) ((* bind EC in *) c : EB) (g : GA)
  | GAf (a : EA) ((* bind DC in *) b : DB) ((* bind EA in *) c : EC) (g : GA).

End ZZZ.
